/*
	TGA CLASS:
	Author: Darshan A Patil
	Date:   2000-2001
	e-mail: dapatil@hotmail.com

	Notes:
	This TGA class,
	Can load 8bit and 24bit TGA files.
	Writes 8 and 24 bit TGA files w/o RLE compression
*/
#ifndef TGA_H
#define TGA_H
#include <stdio.h>

typedef unsigned char byte;

typedef struct
{
	byte id_length;
	byte cmap_type;
	byte image_type;
	byte cmap_specs[5];
	unsigned short int xorg, yorg,width, height;
	byte bpp; //bits per pixel
	byte img_descriptor;
}tga_header;

typedef struct
{
  unsigned char r,g,b;
} colour24;

class tga
{
private:
	void decode8bit(FILE *fp);
	void decode32bit(FILE *fp);
	void decode24bit(FILE *fp);
public:
	int width, height;
	byte pixfmt; //Bytes per pixel.
	byte *data;  //Raw Image Data
	
	tga();
	tga(char *filename);
	~tga();
	
	void load(char *filename);
	void write_24bpp(int width, int height, unsigned char *data, char *filename);
	void write_8bpp(int width, int height, unsigned char *data, char *filename);
	// To be used only for the synthesizer....
	// Uses wrap around mode
	colour24 getCol(int x,int y);
};


#endif


